*macros_random_samples_fixed_number_of_samples.SPS.

SET MPRINT=no.

*///////////////////.
DEFINE !sample2 (file=!TOKENS(1)
	/myvar=!TOKENS(1) 
	/mystat	=!TOKENS(1)
	/nbsampl=!TOKENS(1)
	/size=!CMDEND).
* file=the full path and filename in quotes.
* myvar = the variable of interest.
* mystat = the statistic of interest.
* nbsampl = number of samples.
* size = the size of each samples.

!LET !first='1'
!DO !ss !IN (!size)
!DO !count = 1 !TO !nbsampl

GET FILE='c:\Program Files\SPSS\employee data.sav'.

COMPUTE draw=uniform(1).
SORT CASES BY draw.
N OF CASES !ss.

COMPUTE samplenb=!count. 
COMPUTE ss=!ss.

AGGREGATE OUTFILE=*
  /PRESORTED
  /BREAK=samplenb
  /!myvar = !mystat(!myvar) /ss=FIRST(ss).

!IF (!first !NE '1') !THEN
ADD FILES /FILE=*  /FILE='c:\temp\sample.sav'.
!IFEND
SAVE OUTFILE='c:\temp\sample.sav'.
!LET !first='0'

!DOEND. 
!DOEND. 

FORMAT ss(F8).
VARIABLE LABEL ss 'Size of each sample'
	/!myvar !QUOTE(!CONCAT(!mystat," ",!myvar)).
EXAMINE
  VARIABLES=salary BY ss /PLOT=BOXPLOT/STATISTICS=NONE/NOTOTAL
  /MISSING=REPORT.

!ENDDEFINE.
*//// sample /////////.


* Call macro (parameters are number of samples (here 20) and sizes of sample (here 5, 10,15,30,50). 
* Thus 20 samples of size 5.
* Thus 20 samples of size 10, etc.
SET MPRINT=yes.
!sample2 file='c:\Program Files\SPSS\employee data.sav'
  myvar=salary mystat=mean nbsampl=20 size= 5 10 15 30 50.
